package pwc.taxtech.atms.controller;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import pwc.taxtech.atms.common.message.ErrorMessage;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.exception.ServiceException;
import pwc.taxtech.atms.service.impl.DidiFileUploadService;

@RestController
@RequestMapping("/api/v1/DidiFileUpload")
public class DidiFileUploadController {
    private static final Logger logger = LoggerFactory.getLogger(DidiFileUploadController.class);
    @Autowired
    private DidiFileUploadService didiFileUploadService;


    @ResponseBody
//    @ApiOperation(value = "导入模板")
    @RequestMapping(value = "importTemplateGroupExcelFile", method = RequestMethod.POST)
    public OperationResultDto uploadFile(@RequestParam MultipartFile file) {
        try {
            if (null == file) {
                return OperationResultDto.error(ErrorMessage.NoFile);
            }

            return OperationResultDto.success();
        } catch (ServiceException e) {
            return OperationResultDto.error(e.getMessage());
        } catch (Exception e) {
            logger.error("uploadFile error.", e);
        }
        return OperationResultDto.error(ErrorMessage.SystemError);
    }
//    @PostMapping("queryPage")
//    public CamelPagingResultDto<DidiFileUploadDetailResult> queryPage(@RequestBody DidiFileIUploadParam param) {
//        return new CamelPagingResultDto<>(revenueDetailService.queryPage(param));
//    }
}
