package pwc.taxtech.atms.service.impl;

import com.alibaba.fastjson.JSON;
import org.junit.Test;
import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.dto.ebsdto.*;
import pwc.taxtech.atms.service.EbsApiService;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class EbsApiServiceImplTest extends CommonIT {
    @Resource
    private EbsApiService ebsApiService;
    @Resource
    private DistributedIdService distributedIdService;

    @Test
    public  void testApi(){
        queryRemoteServerThenUpdateJE();
        queryRemoteServerThenUpdateTB();
        queryRemoteServerThenUpdateCF();
        queryRemoteServerThenUpdateBS();
        queryRemoteServerThenUpdateBSprc();
        queryRemoteServerThenUpdatePL();
        queryRemoteServerThenUpdatePLprc();
        queryRemoteServerThenUpdateOAR();
    }
    @Test
    public void queryRemoteServerThenUpdateOrg(){
        List<OrganizationQueryDto> items = new ArrayList();
        for(int i=0;i<2;i++){
            OrganizationQueryDto dto = new OrganizationQueryDto();
            dto.setTaxPayerNumber("sadsafsdf3232");
            dto.setCode("ceshi0009");
            dto.setName("测试成功");
            dto.setEnterpriseAccountCode("test");
            dto.setLegalPersonName("周杰伦");
            dto.setRegistrationCapital("100万");
            dto.setPaidInCapital("200万");
            dto.setLegalPersonPhoneNumber("1239512312");
            dto.setLegalPersonLandlineNum("1234678");
            dto.setLegalPersonEmailAddress("didi@qq.com");
            dto.setRegFinancialOfficerName("周杰伦");
            dto.setRegFinancialOfficerPhoneNum("123141231");
            dto.setRegFinancialOfficerLandlineNum("123213124");
            dto.setRegFinancialOfficerEmailAddress("滴滴大厦");
            dto.setCurrencyCode("CNY");
            dto.setRegisterAddress("滴滴大厦");
            dto.setParentName("滴滴测试");
            dto.setStaffSize(12345);
            items.add(dto);
        }
        String res=JSON.toJSONString(items);
        System.out.println(res);
//        ebsApiService.queryRemoteServerThenUpdateOrg(items);
    }

    @Test
    public  void queryRemoteServerThenUpdateJE(){
        List<JournalEntryQueryDto> items=new ArrayList<>();
        for(int i=0;i<10;i++){
            JournalEntryQueryDto journalEntryQueryDto =new JournalEntryQueryDto();
            journalEntryQueryDto.setSource("来源");
            journalEntryQueryDto.setLedgerId("账套ID");
            journalEntryQueryDto.setLedgerName("账套名称");
            journalEntryQueryDto.setCurrencyCode("账套币种");
            journalEntryQueryDto.setHeaderId("日记账头ID");
            journalEntryQueryDto.setLineNum("日记账行号");
            journalEntryQueryDto.setApprovalStatus("审批状态");
            journalEntryQueryDto.setPostedStatus("过账");
//            journalEntryQueryDto.setPeriod(20180102+i);
            journalEntryQueryDto.setJournalSource("日记账来源");
            journalEntryQueryDto.setCategory("日记账类别");
            journalEntryQueryDto.setName("日记账名称");
            journalEntryQueryDto.setVoucherNum("凭证编号");
            journalEntryQueryDto.setDescription("摘要");
            journalEntryQueryDto.setSegment1("主体代码");
            journalEntryQueryDto.setSegment2("成本中心");
            journalEntryQueryDto.setSegment3("科目代码");
            journalEntryQueryDto.setSegment4("辅助科目");
            journalEntryQueryDto.setSegment5("利润中心");
            journalEntryQueryDto.setSegment6("产品");
            journalEntryQueryDto.setSegment7("项目");
            journalEntryQueryDto.setSegment8("公司间");
            journalEntryQueryDto.setSegment9("备用1");
            journalEntryQueryDto.setSegment10("备用2");
            journalEntryQueryDto.setSegment1Name("主体说明");
            journalEntryQueryDto.setSegment2Name("成本中心说明");
            journalEntryQueryDto.setSegment3Name("科目说明");
            journalEntryQueryDto.setSegment4Name("辅助科目说明");
            journalEntryQueryDto.setSegment5Name("利润中心说明");
            journalEntryQueryDto.setSegment6Name("产品说明");
            journalEntryQueryDto.setSegment7Name("项目说明");
            journalEntryQueryDto.setSegment8Name("公司间说明");
            journalEntryQueryDto.setSegment9Name("备用1说明");
            journalEntryQueryDto.setSegment10Name("备用2说明");
            journalEntryQueryDto.setJournalCurrencyCode("币种");
            journalEntryQueryDto.setSobCurrencyCode("本位币币种");
            journalEntryQueryDto.setAccountedDr(new BigDecimal("123"));
            journalEntryQueryDto.setAccountedCr(new BigDecimal("120.2"));
            journalEntryQueryDto.setEnteredDr(new BigDecimal("1231.0231"));
            journalEntryQueryDto.setEnteredCr(new BigDecimal("120.122"));
            journalEntryQueryDto.setCfItem("现金流量表项");
            journalEntryQueryDto.setAttribute1("城市");
            journalEntryQueryDto.setAttribute3("对方银行账号");
            journalEntryQueryDto.setAttribute4("银行流水号");
            journalEntryQueryDto.setAttribute5("供应商编号");
            journalEntryQueryDto.setAttribute6("交易单号");
            journalEntryQueryDto.setAttribute7("供应商名称");
            journalEntryQueryDto.setAttribute8("接收编码");
            journalEntryQueryDto.setAttribute9("制单人");
            journalEntryQueryDto.setAttribute10("审核人");
            journalEntryQueryDto.setAttribute11("成本中心部门描述1");
            journalEntryQueryDto.setAttribute12("成本中心部门描述2");
            journalEntryQueryDto.setAttribute13("成本中心部门描述3");
            journalEntryQueryDto.setAttribute14("成本中心部门描述4");
            journalEntryQueryDto.setAttribute15("成本中心部门描述5");
            journalEntryQueryDto.setAttribute16("成本中心部门描述6");
            journalEntryQueryDto.setCreatedBy("pwcCreat");
            journalEntryQueryDto.setLateUpdatedBy("pwcUpate");
            items.add(journalEntryQueryDto);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);
        //ebsApiService.queryRemoteServerThenUpdateJE(items);
    }

    @Test
    public void queryRemoteServerThenUpdateTB() {
        List<TrialBalanceQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            TrialBalanceQueryDto result = new TrialBalanceQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setStatus(false);
//            result.setSource("来源");
//            result.setPeriod(201803);
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setCurrencyCode("账套币种");
            result.setCategory("主体性质");
            result.setAccountCategory("科目性质");
            result.setAcctCode1("一级科目代码");
            result.setAcctName1("一级科目说明");
            result.setAcctName2("二级科目说明");
            result.setAcctName3("三级科目说明");
            result.setSegment1("主体代码");
            result.setSegment2("成本中心代码");
            result.setSegment3("科目代码");
            result.setSegment4("辅助科目代码");
            result.setSegment5("利润中心代码");
            result.setSegment6("产品代码");
            result.setSegment7("项目代码");
            result.setSegment8("公司间代码");
            result.setSegment9("备用1代码");
            result.setSegment10("备用2代码");
            result.setSegment1Name("主体说明");
            result.setSegment2Name("成本中心说明");
            result.setSegment3Name("科目说明");
            result.setSegment4Name("辅助科目说明");
            result.setSegment5Name("利润中心说明");
            result.setSegment6Name("产品说明");
            result.setSegment7Name("项目说明");
            result.setSegment8Name("公司间说明");
            result.setSegment9Name("备用1说明");
            result.setSegment10Name("备用2说明");
            result.setBegBal(new BigDecimal("110"));
            result.setPeriodDr(new BigDecimal("110"));
            result.setPeriodCr(new BigDecimal("110"));
            result.setEndBal(new BigDecimal("110"));
            result.setQtdDr(new BigDecimal("110"));
            result.setQtdCr(new BigDecimal("110"));
            result.setYtdDr(new BigDecimal("110"));
            result.setYtdCr(new BigDecimal("110"));
            result.setBegBalBeq(new BigDecimal("110"));
            result.setPeriodDrBeq(new BigDecimal("110"));
            result.setPeriodCrBeq(new BigDecimal("110"));
            result.setEndBalBeq(new BigDecimal("110"));
            result.setQtdDrBeq(new BigDecimal("110"));
            result.setQtdCrBeq(new BigDecimal("110"));
            result.setYtdDrBeq(new BigDecimal("110"));
            result.setYtdCrBeq(new BigDecimal("110"));
            items.add(result);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);
    }

    @Test
    public void queryRemoteServerThenUpdateCF() {

        List<CashFlowQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            CashFlowQueryDto result = new CashFlowQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setSource("来源");
//            result.setPeriod(201803);
//            result.setStatus(true);
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setLedgerCurrencyCode("账套币种");
            result.setEntityCode("机构编码");
            result.setEntityName("机构名称");
            result.setCategory("主体性质");
            result.setFrequency("频度");
            result.setItemName("项目中文名称");
            result.setItemName2("项目英文名称");
            result.setPeriodAmt(new BigDecimal("1000.0454"));
            result.setYtdAmt(new BigDecimal("1000.0454"));
            items.add(result);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);

    }

    @Test
    public void queryRemoteServerThenUpdateBS() {
        List<BalanceSheetQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            BalanceSheetQueryDto result = new BalanceSheetQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setPeriod(201812);
//            result.setStatus(false);
            result.setLedgerCurrencyCode("账套币种");
            result.setEntityCode("机构编码");
            result.setEntityName("机构名称");
            result.setItemName("项目名称");
            result.setEndBal(new BigDecimal("1220.2980"));
            result.setBegBal(new BigDecimal("1220.2980"));
            result.setSource("来源");
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setCategory("主体性质");
            result.setFrequency("频度");
            items.add(result);
        }
            String a=JSON.toJSONString(items);
            System.out.println(a);

    }

    @Test
    public void queryRemoteServerThenUpdateBSprc() {
        List<BalanceSheetPrcQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            BalanceSheetPrcQueryDto result = new BalanceSheetPrcQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setStatus(false);
//            result.setSource("来源");
//            result.setPeriod(201804);
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setLedgerCurrencyCode("账套币种");
            result.setEntityCode("机构编码");
            result.setEntityName("机构名称");
            result.setCategory("主体性质");
            result.setFrequency("频度");
            result.setItemName("项目名称");
            result.setEndBal(new BigDecimal("1220.2980"));
            result.setBegBal(new BigDecimal("1220.2980"));
            items.add(result);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);
    }

    @Test
    public void queryRemoteServerThenUpdatePL() {
        List<ProfitLossStatementQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            ProfitLossStatementQueryDto result = new ProfitLossStatementQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setStatus(false);
//            result.setSource("来源");
//            result.setPeriod(201904);
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setLedgerCurrencyCode("账套币种");
            result.setEntityCode("机构编码");
            result.setEntityName("机构名称");
            result.setCategory("主体性质");
            result.setFrequency("频度");
            result.setItemName("项目名称");
            result.setPeriodAmt(new BigDecimal("1220.2980"));
            result.setYtdAmt(new BigDecimal("1220.2980"));
            items.add(result);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);
    }

    @Test
    public void queryRemoteServerThenUpdatePLprc() {
        List<ProfitLossStatementPrcQueryDto> items=new ArrayList<>();
        for(int i=0;i<2;i++) {
            ProfitLossStatementPrcQueryDto result = new ProfitLossStatementPrcQueryDto();
//            result.setDate("2019-03-04 19:14:17");
//            result.setStatus(false);
//            result.setSource("来源");
//            result.setPeriod(201904);
            result.setLedgerId("账套ID");
            result.setLedgerName("账套名称");
            result.setLedgerCurrencyCode("账套币种");
            result.setEntityCode("机构编码");
            result.setEntityName("机构名称");
            result.setCategory("主体性质");
            result.setFrequency("频度");
            result.setItemName("项目名称");
            result.setPeriodAmt(new BigDecimal("1220.2980"));
            result.setYtdAmt(new BigDecimal("1220.2980"));
            items.add(result);
        }
        String a=JSON.toJSONString(items);
        System.out.println(a);
    }

    @Test
    public void queryRemoteServerThenUpdateOAR() {
            List<OrganizationAccountingRateQueryDto> items=new ArrayList<>();
            for(int i=0;i<2;i++) {
                OrganizationAccountingRateQueryDto result = new OrganizationAccountingRateQueryDto();
//                result.setPeriod(2018);
                result.setConvertionType("汇率类型名称");
                result.setCurrencyFrom("原币种");
                result.setCurrencyTo("目标币种");
                items.add(result);
            }
        String a=JSON.toJSONString(items);
        System.out.println(a);
    }

    @Test
    public void testConvertPeriod(){
        System.out.println(convertPeriod(201813));
        System.out.println(convertPeriod(201814));
        System.out.println(convertPeriod(201812));
        System.out.println(convertPeriod(201810));
        System.out.println(convertPeriod(201811));

    }
    private Integer convertPeriod(Integer period){
        if(period%100==13){
            period--;
        }
        return period;
    }
}